clear all;close all;clc
% cd ..


%Add tensor toolbox to path (for HEINEKEN)
mypath = pwd;
cd ../..
run install_tensor_toolbox
cd(mypath)
%

%Add poblano toolbox to path (for HEINEKEN)
mypath = pwd;
cd ../../../poblano_toolbox
run install_poblano
cd(mypath)
%

allF = [1 5 10 20 30];
% F = 20;
mat{2} = []; mat{3} = [];

% % % % %NELL-BRAIN
load ../../../datasets/NELL-Brain/science-2008/tensors.mat
load ../../../datasets/NELL-Brain/sem_matrix.mat
X = X3;
s = size(X); I = s(1); J = s(2); K = s(3);
mat{1} = sem_matrix;
errors = [];
speedup_serial = [];
speedup_parallel = [];
MAXITER = 5;   

cost_cmtf_opt_dense = zeros(length(allF),MAXITER);
time_cmtf_opt_dense = zeros(length(allF),MAXITER);

cost_cmtf_opt_sparse = zeros(length(allF),MAXITER);
time_cmtf_opt_sparse = zeros(length(allF),MAXITER);


for F = allF
    for i = 1:MAXITER
    % %     tic
    % %     [A2 B2 C2 outmatrices2 cost2] = CMTF(X,mat,F);
    % %     time_cmtf_als_sparse(i) = toc;
        F
        i
         tic;
        [Fac cost_cmtf_opt_dense(i)]= cmtf_opt_wrapper(tensor(X),full(sem_matrix),F);
        time_cmtf_opt_dense(i) = toc;
        time_cmtf_opt_dense(i)
        save results_cmtf_opt.mat cost_cmtf_opt_dense time_cmtf_opt_dense cost_cmtf_opt_sparse time_cmtf_opt_sparse
    end
end
disp('DONE WITH DENSE');
for F = allF
    for i = 1:MAXITER
        tic;
        [Fac cost_cmtf_opt_sparse(i)]= cmtf_opt_wrapper(X,sem_matrix,F);
        time_cmtf_opt_sparse(i) = toc;
        time_cmtf_opt_sparse(i)    
        save results_cmtf_opt.mat cost_cmtf_opt_dense time_cmtf_opt_dense cost_cmtf_opt_sparse time_cmtf_opt_sparse

    end
end
 
save results_cmtf_opt.mat cost_cmtf_opt_dense time_cmtf_opt_dense cost_cmtf_opt_sparse time_cmtf_opt_sparse
    
% % % % % 
% % % % % rng('default')
% % % % % all_s = [2 5 10 20] 
% % % % % % all_s = 10
% % % % % 
% % % % % cost_turbo = zeros(length(all_s),MAXITER);
% % % % % time_turbo = zeros(length(all_s),MAXITER);
% % % % % 
% % % % % count = 1;
% % % % % matlabpool open 4
% % % % % for s = all_s
% % % % %     sample_factor = [s/2 s 1];
% % % % %     for it = 1:MAXITER
% % % % %         repetitions = 4;
% % % % %         nonneg = 0;
% % % % % 
% % % % %         disp('parallel')
% % % % %         [A B C outmatrices lambda paralleltime serialtime] = coupled_parCube_parallel(X,mat,F,sample_factor,repetitions,nonneg);
% % % % %         time_turbo(find(s == all_s),it) = (paralleltime) + serialtime
% % % % %         
% % % % %         UC = (sptenmat(X,3,'bc'));  UC = sparse(UC.subs(:,1), UC.subs(:,2),UC.vals,size(UC,1),size(UC,2));UC = UC';
% % % % %         xx =  khatrirao(A,B)*diag((lambda(1,:)).*(lambda(2,:)).*(lambda(3,:)) )*C';
% % % % %         D = outmatrices{1};
% % % % %         cost_turbo(find(s == all_s),it) =  norm(UC - xx ,'fro')^2 + norm(sem_matrix - A*D','fro')^2;
% % % % %         
% % % % %     end
% % % % % count = count+1;
% % % % % end
% % % % % % cd('correctness-scalability/')
% % % % % matlabpool close
% % % % % 
% % % % % 
% % % % % save results_after_review.mat cost_cmtf_opt_dense time_cmtf_opt_dense cost_cmtf_opt_sparse time_cmtf_opt_sparse cost_cmtf_als_dense time_cmtf_als_dense cost_cmtf_als_sparse time_cmtf_als_sparse time_turbo cost_turbo
