clear all;close all;clc
%Vagelis Papalexakis, 2013-2014
%School of Computer Science, Carnegie Mellon University
%Script that reads the files downloaded from 
%[http://www.cs.cmu.edu/afs/cs/project/theo-73/www/science2008/data.html] 
%and creates the tensor of the BrainQ dataset

X3 = sptensor([60 21764 8]);%words x voxels x human subjects
X4 = sptensor([60 360 21764 8]);%words X trials x voxels x human subjects
X3 = double(X3); X4 = double(X4);

files = dir;
for f = 4:11%12
    %load the data of the f-th human subject
    files(f).name
    load(files(f).name);
    bwords = {}; for i = 1:length(info),bwords(i) = cellstr(info(i).word);end;uwords = unique(bwords);
    newdata = {};
    for i = 1:length(uwords),  
        tmp = zeros(length(data{1}),6);
        [junk idx] = ismember(bwords,uwords(i));
        idx = find(idx);
        for j = 1:6
            tmp(:,j) = data{idx(j)};
            X4(i,idx(j),1:length(tmp(:,j)),f-2) = tmp(:,j);
        end
        newdata{i} = mean(tmp,2)';
    end;
    for j = 1:60
       X3(j,1:length(newdata{j}),f-2) = newdata{j}; 
    end
    disp('end of iteration')
end
X3 = tensor(X3); X4 = tensor(X4);
save tensors.mat